SystemOrganization addCategory: #'ImageWriter-Core'!

Object subclass: #HzImageFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzImageFormat commentStamp: '<historical>' prior: 0!
A HzImageFormat represents information about image.!

HzImageFormat subclass: #HzCogImageFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzCogImageFormat commentStamp: '<historical>' prior: 0!
A HzCogImageFormat represents Cog specific encodings of image.!

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:22'!
flagInterpretedMethods
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 6/6/2012 10:24'!
imageHeaderFlags
	"Answer the flags that are contained in the 7th long of the image header."
	^ (self isFullScreenFlag                ifTrue: [0] ifFalse: [1]) "0 or 1"
	+ (self isLittleEndian                  ifTrue: [0] ifFalse: [2]) "this is the imageFloatsLittleEndian flag"
	+ (self processHasThreadId        ifTrue: [4] ifFalse: [0])
	+ (self flagInterpretedMethods   ifTrue: [8] ifFalse: [0])
	+ (self preemptionYields             ifTrue: [0] ifFalse: [16])
	+ (self noThreadingOfGUIThread ifTrue: [32] ifFalse: [0])! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/24/2012 16:43'!
isFullScreenFlag
	^true! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 6/6/2012 18:12'!
isLittleEndian
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:22'!
noThreadingOfGUIThread
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:22'!
preemptionYields
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:21'!
processHasThreadId
	^false! !

!HzCogImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/23/2012 16:00'!
versionNumber
	^6505! !

!HzCogImageFormat methodsFor: 'writing' stamp: 'JenkinsJob 7/29/2012 15:33'!
writeImageHeaderOn: byteStream forWriter: aWriter
	| nextPutLong buffer |
	buffer := WordArray new: 1.
	nextPutLong := [ :number | byteStream nextPutAll: (buffer at: 1 put: number; yourself) ].
	
	nextPutLong value: self versionNumber.
	nextPutLong value: self imageHeaderSize.
	nextPutLong value: aWriter finalSize - self imageHeaderSize.
	nextPutLong value: self imageHeaderSize.  "start of memory"
	nextPutLong value: aWriter specialObjectsOop.
	nextPutLong value: self lastHash.
	nextPutLong value: 800 * 16r10000 + 600.
	nextPutLong value: self imageHeaderFlags.
	nextPutLong value: Smalltalk vm extraVMMemory.
	nextPutLong value: (((Smalltalk vm parameterAt: 43) bitShift: 16) + (Smalltalk vm parameterAt: 47)).
	nextPutLong value: (Smalltalk vm parameterAt: 45).
	nextPutLong value: (((Smalltalk vm parameterAt: 49) bitAnd: 16) bitShift: 16).
	byteStream padTo: self imageHeaderSize put: 0.
! !

!HzImageFormat methodsFor: 'header' stamp: 'StephaneDucasse 4/30/2012 21:27'!
imageHeaderSize

	^ 64  "bytes"! !

!HzImageFormat methodsFor: 'header' stamp: 'StephaneDucasse 4/30/2012 21:25'!
lastHash
	^ Object new basicIdentityHash! !

!HzImageFormat methodsFor: 'accessing' stamp: 'StephaneDucasse 4/30/2012 21:27'!
objectMemoryStart
	^self imageHeaderSize! !

!HzImageFormat methodsFor: 'header' stamp: 'StephaneDucasse 4/30/2012 21:26'!
versionNumber
	"Image format version number"
	
	^ self subclassResponsibility ! !

!HzImageFormat methodsFor: 'accessing' stamp: 'StephaneDucasse 4/30/2012 21:25'!
wordSize
	"Return the number of bytes that a word is encoded on."

	^4 "bytes.  We support 32 bit platforms only"! !

!HzImageFormat methodsFor: 'writing' stamp: 'StephaneDucasse 4/30/2012 21:28'!
writeImageHeaderOn: byteStream forWriter: aWriter

	self subclassResponsibility ! !

HzImageFormat subclass: #HzInterpreterImageFormat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzInterpreterImageFormat commentStamp: '<historical>' prior: 0!
HzInterpreterImageFormat represents the information related to the image for an interpreter VM.!

!HzInterpreterImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/20/2012 18:50'!
hasBlockClosureSupport
	"true if this image has proper blockclosure support"
	
	| bc |
	[bc := [:b :e | e > 1
		ifFalse: [b value: bc value: e + 1]
		ifTrue: [e]].
	bc value: bc value: 1.
	^true]
		on: Error
		do: [^false]! !

!HzInterpreterImageFormat methodsFor: 'header' stamp: 'GuillermoPolito 4/20/2012 18:47'!
versionNumber
	"Image format version number"

	self hasBlockClosureSupport
		ifTrue: [^6504]
		ifFalse: [^6502]! !

!HzInterpreterImageFormat methodsFor: 'writing' stamp: 'GuillermoPolito 6/29/2012 16:25'!
writeImageHeaderOn: byteStream forWriter: aWriter
	| nextPutLong buffer |
	buffer := WordArray new: 1.
	nextPutLong := [ :number | byteStream nextPutAll: (buffer at: 1 put: number; yourself) ].
	
	nextPutLong value: self versionNumber.
	nextPutLong value: self imageHeaderSize.
	nextPutLong value: aWriter finalSize - self imageHeaderSize.
	nextPutLong value: self imageHeaderSize.  "start of memory"
	nextPutLong value: aWriter specialObjectsOop.
	nextPutLong value: self lastHash.
	nextPutLong value: 800 * 16r10000 + 600.
	nextPutLong value: 0.  "fullScreenFlag"
	nextPutLong value: Smalltalk vm extraVMMemory.
	byteStream padTo: self imageHeaderSize put: 0.
! !

Object subclass: #HzImageWriter
	instanceVariableNames: 'theImageFileName imageToWrite closureEnsurer specialObjectsArray oopMap traceQueue byteStream nextChunk displayBox swapMap imageFormat initializationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzImageWriter commentStamp: '<historical>' prior: 0!
A HzImageWriter is actually tracing and creating a new image.!

!HzImageWriter methodsFor: 'testing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
areWeInClone
	^byteStream isNil! !

!HzImageWriter methodsFor: 'run' stamp: 'GuillermoPolito 4/26/2012 12:23'!
basicWriteImage
	| contextCopy |
	"we make the executing context restart from out of here so it gets initialized"
	contextCopy := thisContext copy.
	contextCopy push: nil.
	swapMap 
		at: Processor activeProcess 
		put: (Process forContext: contextCopy sender priority: Processor activePriority).

	"and we write the image!!"
	[
		nextChunk := imageFormat objectMemoryStart.
		Smalltalk garbageCollect.
		self traceImage.
		self writeFileHeader.
	] ensure: [ 
		self closeImageFile.
	].
! !

!HzImageWriter methodsFor: 'private' stamp: 'GuillermoPolito 4/26/2012 12:23'!
closeImageFile
	byteStream close.! !

!HzImageWriter methodsFor: 'object replacement' stamp: 'GuillermoPolito 4/26/2012 12:23'!
convert: obj pointer: pointer field: index
	"fix for named primitives cache"
	^swapMap at: obj ifAbsent: [ obj ]! !

!HzImageWriter methodsFor: 'private' stamp: 'GuillermoPolito 4/26/2012 12:23'!
copyChangesFile
	(SourceFiles at: 2) ifNotNil:[
		SmalltalkImage current saveChangesInFileNamed: (SmalltalkImage current fullNameForChangesNamed: self imageFileName)].! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
finalSize
	^nextChunk! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
format
	^imageFormat! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
format: anImageFormat
	imageFormat := anImageFormat.! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
imageFileName
	^theImageFileName! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
imageFileName: imageFileName
	theImageFileName := imageFileName.! !

!HzImageWriter methodsFor: 'initialize-release' stamp: 'GuillermoPolito 6/20/2012 11:30'!
initialize
	super initialize.
	oopMap := IdentityDictionary new.
	traceQueue := OrderedCollection new.
	initializationBlock := [].
	imageFormat := HzCogImageFormat new.
	self initializeSwapMap.! !

!HzImageWriter methodsFor: 'initialize-release' stamp: 'GuillermoPolito 6/15/2012 11:24'!
initializeNewImageFile
	byteStream := FileStream newFileNamed: self imageFileName, '.image'.
	byteStream binary.! !

!HzImageWriter methodsFor: 'initialize-release' stamp: 'GuillermoPolito 4/26/2012 12:23'!
initializeSwapMap
	swapMap := IdentityDictionary new: 4000.
	swapMap at: self put: self class basicNew.! !

!HzImageWriter methodsFor: 'oop resolution' stamp: 'StephaneDucasse 4/30/2012 21:56'!
integerOopOf: value
	
	value < 0
		ifTrue: [^ ((16r80000000 + value) << 1) + 1]
		ifFalse: [^ (value << 1) + 1]! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
onInitializeDo: aBlock
	initializationBlock := aBlock! !

!HzImageWriter methodsFor: 'oop resolution' stamp: 'StephaneDucasse 4/30/2012 21:40'!
oopForObject: anObject
	"Return the object pointer of the argument."
	
	anObject class = SmallInteger ifTrue: [^ self integerOopOf: anObject ].
	^oopMap at: (swapMap at: anObject ifAbsent: [anObject])! !

!HzImageWriter methodsFor: 'reserving' stamp: 'StephaneDucasse 4/30/2012 21:11'!
reserve: object
	"Add object to write queue and return its oop"
	| oop theFormat |
	
	theFormat := HzObjectFormat for: object withOopProvider: self withFormat: imageFormat.
	
	oop := nextChunk + ((theFormat amountOfHeaders - 1) * imageFormat wordSize).
	nextChunk := oop + (theFormat bodyLength * imageFormat wordSize).

	"Add object to fill queue and remember its oop"
	oopMap at: object put: oop.
	traceQueue addLast: object.
	^ oop! !

!HzImageWriter methodsFor: 'reserving' stamp: 'GuillermoPolito 4/26/2012 12:23'!
reserve: obj from: pointer field: index
	"Add obj to write queue and return its oop"

	| object |
	obj class = SmallInteger ifTrue: [^ self integerOopOf: obj].

	"Return oop if already visited obj"
	object := self convert: obj pointer: pointer field: index.
	oopMap at: object ifPresent: [:itsOop | ^ itsOop].

	^ self reserve: object! !

!HzImageWriter methodsFor: 'private' stamp: 'GuillermoPolito 6/20/2012 11:28'!
specialObjectsArray
	^specialObjectsArray ifNil: [ specialObjectsArray := imageToWrite specialObjectsArray ]! !

!HzImageWriter methodsFor: 'accessing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
specialObjectsOop
	^oopMap at: self specialObjectsArray! !

!HzImageWriter methodsFor: 'object replacement' stamp: 'GuillermoPolito 5/3/2012 11:16'!
substitute: anObject by: anotherObject
	^swapMap at: anObject put: anotherObject! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
traceImage
	"Trace image starting with true, false, nil, and specialObjectsArray"

	"Add true and false in front so the VM can assume it will never move (see Interpreter>>interpret)"
	self reserve: nil.
	self reserve: false.
	self reserve: true.
	self reserve: self specialObjectsArray.	
	
	"Write and trace rest of image"
	[traceQueue isEmpty] whileFalse: [
		self writeAndTrace: traceQueue removeFirst.
	].
! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeAndTrace: object
	"Write the image representation of me on byteStream at my oop, and add my not-yet-seen fields to traceQueue."

	| oop  objectFormat |
	oop := oopMap at: object ifAbsent: [self error: object printString, ' has not oop assigned'].
	objectFormat := HzObjectFormat for: object withOopProvider: self withFormat: imageFormat.
	
	self reserve: object class from: object field: -1.
	self writeObjectHeaderOf: objectFormat.
	self writeFieldsFor: objectFormat.

	"Double check that fields take up expected size"
	byteStream position = (oop + (objectFormat bodyLength * imageFormat wordSize)) ifFalse: [
		self error: 'object size discrepency'].
	^ oop! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeFieldsFor: theFormat
	theFormat indexedFields withIndexDo: [:val :i | self reserve: val from: theFormat realObject field: i].
	theFormat writeOn: byteStream withOopProvider: self.! !

!HzImageWriter methodsFor: 'writing' stamp: 'GuillermoPolito 4/26/2012 12:23'!
writeFileHeader
	byteStream position: 0.
	imageFormat
		writeImageHeaderOn: byteStream
		forWriter: self.! !

!HzImageWriter methodsFor: 'run' stamp: 'GuillermoPolito 6/20/2012 12:06'!
writeImage: aSmalltalkImage
	| initializationBlockCopy |

	[
	imageToWrite := aSmalltalkImage.
		
	self initializeNewImageFile.
	self copyChangesFile.

	"We copy the initialization block because we want to access it after copying the image :)"
	initializationBlockCopy := initializationBlock copy.	

	(aSmalltalkImage == Smalltalk)
		ifTrue: [ Smalltalk shutDownImage: true ].
	
	
		[self basicWriteImage] ensure:
			[
			(aSmalltalkImage == Smalltalk)
				ifTrue: [ Smalltalk startupImage: self areWeInClone snapshotWorked:  true ].
			self areWeInClone ifTrue: initializationBlockCopy.
			]
	] on: Abort do: [ byteStream ifNotNilDo: #close ]! !

!HzImageWriter methodsFor: 'writing' stamp: 'StephaneDucasse 4/30/2012 21:11'!
writeObjectHeaderOf: objectFormat
	"Write header"
	byteStream position: objectFormat oop - ((objectFormat amountOfHeaders - 1) * imageFormat wordSize).
	byteStream nextPutAll: ((objectFormat headers collect: [ :h | h valueFor: self ]) asWordArray).! !

Object subclass: #HzQuestionsForGuillermo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ImageWriter-Core'!

!HzQuestionsForGuillermo commentStamp: '<historical>' prior: 0!
Why HzCogImageFormat and HZInterpreterImageFormat do not share a common interface?

Why hasBlockClosureSupport is not defined on Cog?

I would like to understand the defintion of 
integerOopOf: value

I do not like its name: oopForInteger would be better?!
